## insighttoolkit4 4.5.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.6 FATAL_ERROR)
include(CMakeDependentOption)
#
# use ExternalProject
include(ExternalProject)

if(WIN32)
  cmake_minimum_required(VERSION 2.8.8)
endif()

project(ITK)

if( CMAKE_HOST_WIN32 )

  string( LENGTH "${CMAKE_CURRENT_SOURCE_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "ITK source code directory path length is too long (${n} > 50)."
      "Please move the ITK source code directory to a directory with a shorter path."
      )
  endif()

  string( LENGTH "${CMAKE_CURRENT_BINARY_DIR}" n )
  if( n GREATER 50 )
    message(
      FATAL_ERROR
      "ITK build directory path length is too long (${n} > 50)."
      "Please set the ITK build directory to a directory with a shorter path."
      )
  endif()

endif()

set(CMAKE_MODULE_PATH ${ITK_SOURCE_DIR}/CMake ${CMAKE_MODULE_PATH})
include(PreventInSourceBuilds)
include(PreventInBuildInstalls)
include(ITKModuleMacros)
include(ITKExternalData)
include(itkCheckSourceTree)

set(main_project_name ${_ITKModuleMacros_DEFAULT_LABEL})

#-----------------------------------------------------------------------------
# ITK version number.
set(ITK_VERSION_MAJOR "4")
set(ITK_VERSION_MINOR "5")
set(ITK_VERSION_PATCH "0")

if(NOT ITK_INSTALL_RUNTIME_DIR)
  set(ITK_INSTALL_RUNTIME_DIR bin)
endif()
if(NOT ITK_INSTALL_LIBRARY_DIR)
  set(ITK_INSTALL_LIBRARY_DIR lib)
endif()
if(NOT ITK_INSTALL_ARCHIVE_DIR)
  set(ITK_INSTALL_ARCHIVE_DIR lib)
endif()
if(NOT ITK_INSTALL_INCLUDE_DIR)
  set(ITK_INSTALL_INCLUDE_DIR include/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR})
endif()
if(NOT ITK_INSTALL_DATA_DIR)
  set(ITK_INSTALL_DATA_DIR share/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR})
endif()
if(NOT ITK_INSTALL_DOC_DIR)
  set(ITK_INSTALL_DOC_DIR share/doc/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR})
endif()
if(NOT ITK_INSTALL_PACKAGE_DIR)
  set(ITK_INSTALL_PACKAGE_DIR "lib/cmake/ITK-${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}")
endif()

# Override CMake's built-in add_* commands: assign LABELS to tests and targets
# automatically. Depends on the CMake variable itk-module being set to the
# "current" module when add_* is called.
macro(verify_itk_module_is_set)
  if("" STREQUAL "${itk-module}")
    message(FATAL_ERROR "CMake variable itk-module is not set")
  endif()
endmacro()

#-----------------------------------------------------------------------------
# Set a default build type if none was specified
if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build." FORCE)
  # Set the possible values of build type for cmake-gui
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()


#-----------------------------------------------------------------------------
# Enable runinng cppcheck for each module on its source and test directories.
option(ITK_CPPCHECK_TEST "Run cppcheck for static code analysis" OFF)
mark_as_advanced(ITK_CPPCHECK_TEST)


#-----------------------------------------------------------------------------
# Enable the download and use of BrainWeb datasets.
# When this data is available, additional 3D tests are enabled.
option(ITK_USE_BRAINWEB_DATA "Download and use BrainWeb data for advanced testing" OFF)
mark_as_advanced(ITK_USE_BRAINWEB_DATA)

#-----------------------------------------------------------------------------
# ITK wrapper for add_test that automatically sets the test's LABELS property
# to the value of its containing module.
#
function(itk_add_test)
  # Add tests with data in the ITKData group.
  ExternalData_add_test(ITKData ${ARGN})

  if("NAME" STREQUAL "${ARGV0}")
    set(_iat_testname ${ARGV1})
  else()
    set(_iat_testname ${ARGV0})
  endif()

  if(itk-module)
    set(_label ${itk-module})
    if(TARGET ${itk-module}-all AND "${ARGN}" MATCHES "DATA{")
      add_dependencies(${itk-module}-all ITKData)
    endif()
  else()
    set(_label ${main_project_name})
  endif()

  set_property(TEST ${_iat_testname} PROPERTY LABELS ${_label})
endfunction()

#-----------------------------------------------------------------------------
# ITK macro to ignore a test during MemCheck
#
macro(itk_memcheck_ignore)
  set_property(GLOBAL APPEND PROPERTY CTEST_CUSTOM_MEMCHECK_IGNORE ${ARGN})
endmacro()

#-----------------------------------------------------------------------------
# ITK build configuration options.
option(BUILD_SHARED_LIBS "Build ITK with shared libraries." OFF)
set(ITK_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

include(ITKSetStandardCompilerFlags)
#---------------------------------------------------------------
# run try compiles and tests for ITK
include(itkTestFriendTemplatedFunction)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${ITK_REQUIRED_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ITK_REQUIRED_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")

include(CTest)

include( CppcheckTargets )

# Setup build locations.
if(NOT CMAKE_RUNTIME_OUTPUT_DIRECTORY)
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${ITK_BINARY_DIR}/bin)
endif()
if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${ITK_BINARY_DIR}/lib)
endif()
if(NOT CMAKE_ARCHIVE_OUTPUT_DIRECTORY)
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${ITK_BINARY_DIR}/lib)
endif()
set(ITK_MODULES_DIR "${ITK_BINARY_DIR}/${ITK_INSTALL_PACKAGE_DIR}/Modules")


#-----------------------------------------------------------------------------
# Provide compatibility options.
option(ITKV3_COMPATIBILITY "Enable compatibility with ITK3.x when possible." OFF)
option(ITK_LEGACY_REMOVE "Remove all legacy code completely." OFF)
option(ITK_LEGACY_SILENT "Silence all legacy code messages." OFF)
# The ITK_FUTURE_LEGACY_REMOVE is a very advanced feature only
# available to developers at configuration time by manually
# adding this to the CMakeCache.txt -DITK_FUTURE_LEGACY_REMOVE:BOOL=ON
set( ITK_FUTURE_LEGACY_REMOVE 0 CACHE INTERNAL "Remove code that will become legacy in future releases completely." )
mark_as_advanced(ITK_LEGACY_SILENT ITK_LEGACY_REMOVE ITK_V3_COMPATIBILITY)

# The disabling of legacy code, and the ITKv3 compatibility option can not both be
# requested.  If removal of legacy code is requested, then ITKV3_COMPATIBILITY must
# be off.
if(ITKV3_COMPATIBILITY AND ITK_LEGACY_REMOVE)
  message(FATAL_ERROR "Invlaid configuration: ITKV3_COMPATIBILITY AND ITK_LEGACY_REMOVE can not both be ON")
endif()

#-----------------------------------------------------------------------------
# ITK build classes that are in the review process
# ITK_USE_REVIEW is deprecated, only kept for backward compatibility
if (ITK_USE_REVIEW AND NOT Module_ITKReview)
  message(WARNING "ITK_USE_REVIEW is deprecated, please use Module_ITKReview to turn Review module ON/OFF")
  set(Module_ITKReview ON CACHE BOOL "Module containing code from the Review directory of ITKv3." FORCE)
endif()

#-----------------------------------------------------------------------------
# ITK uses KWStyle for checking the coding style
include(${ITK_SOURCE_DIR}/Utilities/KWStyle/KWStyle.cmake)

#-----------------------------------------------------------------------------
# By default, ITK builds the Examples that are illustrated in the Software Guide
option(BUILD_EXAMPLES "Build the Examples directory." ON)

#-----------------------------------------------------------------------------
# Enable GPU support. Requires OpenCL to be installed
option(ITK_USE_GPU "GPU acceleration via OpenCL" OFF)
mark_as_advanced(ITK_USE_GPU)

if( ITK_USE_GPU )
   include(itkOpenCL)
endif()

#-----------------------------------------------------------------------------
# Manage FFT v3 Options
#
# ITK_USE_FFTWD -- use double precision fftw
if(DEFINED USE_FFTWD)
  set(ITK_USE_FFTWD_DEFAULT ${USE_FFTWD})
else()
  set(ITK_USE_FFTWD_DEFAULT OFF)
endif()
option(ITK_USE_FFTWD "Use double precision fftw if found" ${ITK_USE_FFTWD_DEFAULT})
mark_as_advanced(ITK_USE_FFTWD)
#
# ITK_USE_FFTWF -- use single precision fftw
if(DEFINED USE_FFTWF)
  set(ITK_USE_FFTWF_DEFAULT ${USE_FFTWF})
else()
  set(ITK_USE_FFTWF_DEFAULT OFF)
endif()
option(ITK_USE_FFTWF "Use single precision fftw if found" ${ITK_USE_FFTWF_DEFAULT})
mark_as_advanced(ITK_USE_FFTWF)

# ITK_USE_SYSTEM_FFTW -- locate a readybuilt fftw installation
if(DEFINED USE_SYSTEM_FFTW)
  set(ITK_USE_SYSTEM_FFTW_DEFAULT ${USE_SYSTEM_FFTW})
else()
  set(ITK_USE_SYSTEM_FFTW_DEFAULT OFF)
endif()
option(ITK_USE_SYSTEM_FFTW "Use an installed version of fftw" ${ITK_USE_SYSTEM_FFTW_DEFAULT})
mark_as_advanced(ITK_USE_SYSTEM_FFTW)


if( ITK_USE_FFTWD OR ITK_USE_FFTWF )
  include(itkExternal_FFTW)
endif()

if(NOT ITKV3_COMPATIBILITY)
  option(ITK_USE_64BITS_IDS "When ON, ITK will use 64 bits integers to index pixels. This is needed for managing images larger than 4Gb in some platforms." OFF)
  mark_as_advanced(ITK_USE_64BITS_IDS)
endif()

# ITK turn on concept checking
option(ITK_USE_CONCEPT_CHECKING "Turn on concept checking to give helpful errors at compile time if a type cannot be used as a template parameter." ON)
mark_as_advanced(ITK_USE_CONCEPT_CHECKING)
option(ITK_USE_STRICT_CONCEPT_CHECKING "Turn on Strict concept checking to give more stringent errors at compile time if a type cannot be used as a template parameter." OFF)
mark_as_advanced(ITK_USE_STRICT_CONCEPT_CHECKING)

#----------------------------------------------------------------------------
set(ITK_TEST_OUTPUT_DIR "${ITK_BINARY_DIR}/Testing/Temporary")

# Configure the default ITK_DATA_ROOT for the location of ITK Data.
set(ITK_DATA_ROOT ${ITK_SOURCE_DIR}/Testing/Data)

# Location of ITK Example Data.
set(ITK_EXAMPLE_DATA_ROOT "${ITK_SOURCE_DIR}/Examples/Data")

#This flag is used in particular, to enable some tests that require large memory to run.
# This probably can be discovered at configuration time by CMake. (Check with CMake developers).
set(ITK_COMPUTER_MEMORY_SIZE 1 CACHE STRING "Provide here the size of your RAM Memory in GigaBytes")
mark_as_advanced(ITK_COMPUTER_MEMORY_SIZE)

#This flag sets the floating point type used in itk::ImageBase for
# spacing/direction/origin to single precision
option(ITK_USE_FLOAT_SPACE_PRECISION "Use single precision for origin/spacing/directions in itk::Image" OFF)
mark_as_advanced(ITK_USE_FLOAT_SPACE_PRECISION)

#----------------------------------------------------------------------
# Make sure remote modules are downloaded before sorting out the module
# dependencies.
add_subdirectory(Modules/Remote)

# Enable modules according to user inputs and the module dependency DAG.
include(ITKModuleEnablement)

#----------------------------------------------------------------------
# Generate ITKConfig.cmake for the build tree.
set(ITK_CONFIG_CODE "
set(ITK_MODULES_DIR \"${ITK_MODULES_DIR}\")")
set(ITK_USE_FILE "${ITK_SOURCE_DIR}/CMake/UseITK.cmake")
set(ITK_CONFIG_TARGETS_CONDITION " AND NOT ITK_BINARY_DIR")
set(ITK_CONFIG_TARGETS_FILE "${ITK_BINARY_DIR}/ITKTargets.cmake")
set(ITK_CONFIG_MODULE_API_FILE "${ITK_SOURCE_DIR}/CMake/ITKModuleAPI.cmake")
configure_file(CMake/ITKConfig.cmake.in ITKConfig.cmake @ONLY)

# Generate ITKConfig.cmake for the install tree.
set(ITK_CONFIG_CODE "
# Compute the installation prefix from this ITKConfig.cmake file location.
get_filename_component(ITK_INSTALL_PREFIX \"\${CMAKE_CURRENT_LIST_FILE}\" PATH)")
# Construct the proper number of get_filename_component(... PATH)
# calls to compute the installation prefix.
string(REGEX REPLACE "/" ";" _count "${ITK_INSTALL_PACKAGE_DIR}")
foreach(p ${_count})
  set(ITK_CONFIG_CODE "${ITK_CONFIG_CODE}
get_filename_component(ITK_INSTALL_PREFIX \"\${ITK_INSTALL_PREFIX}\" PATH)")
endforeach()
set(ITK_CONFIG_CODE "${ITK_CONFIG_CODE}

=== Examples/CMakeLists.txt ===
if(NOT ITK_BUILD_DEFAULT_MODULES)
  message(FATAL_ERROR "BUILD_EXAMPLES requires ITK_BUILD_DEFAULT_MODULES to be ON")
endif()

find_package(ITK REQUIRED)
include(${ITK_USE_FILE})

set(ITK_TEST_DRIVER itkTestDriver)

add_subdirectory(Iterators)
add_subdirectory(DataRepresentation)
add_subdirectory(Filtering)
add_subdirectory(IO)
add_subdirectory(Numerics)
add_subdirectory(Registration)
add_subdirectory(Segmentation)
add_subdirectory(SpatialObjects)
add_subdirectory(Statistics)

=== Wrapping/CMakeLists.txt ===
#==========================================================================
#
#   Copyright Insight Software Consortium
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#          http://www.apache.org/licenses/LICENSE-2.0.txt
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
#==========================================================================*/

project(WrapITK)

# set an internal cache to mark when this file is parsed
set(ITK_WRAPPING_REACHED ON CACHE INTERNAL "Wrapping folder has been reached")

# check cmake version
# Require 2.4.2 for MATH and LIST commands (REMOVE_ITEM is not the same in
# 2.4.1)
# 2.4.5 is required to parse the if(POLICY) command.
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
if(COMMAND CMAKE_POLICY)
  cmake_policy(SET CMP0003 NEW)
  if(POLICY CMP0011)
    cmake_policy(SET CMP0011 NEW)
  endif()
endif()
include("CMakeUtilityFunctions.cmake")

set(ITK_VERSION "${ITK_VERSION_MAJOR}.${ITK_VERSION_MINOR}.${ITK_VERSION_PATCH}")
if(NOT "${CMAKE_VERSION}" STRLESS "2.6.3")
  cmake_policy(SET CMP0011 OLD)
endif()

enable_testing()

###############################################################################
# Config ITKWrap
###############################################################################

# Set up options needed for ConfigureWrapping

# set WrapITK version
set(WrapITK_VERSION_MAJOR 0)
set(WrapITK_VERSION_MINOR 4)
set(WrapITK_VERSION_PATCH 0)


option(ITK_WRAP_unsigned_char "Wrap unsigned char type" ON)
option(ITK_WRAP_unsigned_short "Wrap unsigned short type" OFF)
option(ITK_WRAP_unsigned_long "Wrap unsigned long type" OFF)

option(ITK_WRAP_signed_char "Wrap signed char type" OFF)
option(ITK_WRAP_signed_short "Wrap signed short type" ON)
option(ITK_WRAP_signed_long "Wrap signed long type" OFF)

option(ITK_WRAP_float "Wrap float type" ON)
option(ITK_WRAP_double "Wrap double type" OFF)

option(ITK_WRAP_vector_float "Wrap vector float type" ON)
option(ITK_WRAP_vector_double "Wrap vector double type" OFF)

option(ITK_WRAP_covariant_vector_float "Wrap covariant vector float type" ON)
option(ITK_WRAP_covariant_vector_double "Wrap covariant vector double type" OFF)

option(ITK_WRAP_rgb_unsigned_char "Wrap RGB< unsigned char > type" ON)
option(ITK_WRAP_rgb_unsigned_short "Wrap RGB< unsigned short > type" OFF)

option(ITK_WRAP_rgba_unsigned_char "Wrap RGBA< unsigned char > type" ON)
option(ITK_WRAP_rgba_unsigned_short "Wrap RGBA< unsigned short > type" OFF)

option(ITK_WRAP_complex_float "Wrap complex<float> type" ON)
option(ITK_WRAP_complex_double "Wrap complex<double> type" OFF)

set(ITK_WRAP_DIMS "2;3" CACHE STRING "Dimensions available separated by semicolons (;)")

option(INSTALL_WRAP_ITK_COMPATIBILITY "Install FindWrapITK.cmake and WrapITK.pth (so cmake and python can find WrapITK) as part of the standard installation process. This requires admin privileges. These files can be separately installed by making the install_wrapitk_compatibility target. " ON)

if(ITK_INSTALL_PACKAGE_DIR)
  string(REGEX REPLACE "^/" "" path "${ITK_INSTALL_PACKAGE_DIR}/WrapITK/")
else()
  set(path "lib/InsightToolkit/WrapITK/")
endif()
set(WRAP_ITK_INSTALL_PREFIX "${path}" CACHE INTERNAL "subpath where where most of WrapITK files will be installed")

# Output directories.
set(WRAP_ITK_CONFIG_DIR "${WrapITK_SOURCE_DIR}/")
set(WRAP_ITK_CMAKE_DIR "${WrapITK_SOURCE_DIR}")
set(ITK_WRAP_JAVA_DIR "${WrapITK_BINARY_DIR}/Java")

if(NOT CMAKE_LIBRARY_OUTPUT_DIRECTORY)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${WrapITK_BINARY_DIR}/lib CACHE INTERNAL "Single output directory for building all libraries.")
endif()

if(NOT EXECUTABLE_OUTPUT_PATH)
  set(EXECUTABLE_OUTPUT_PATH ${WrapITK_BINARY_DIR}/bin CACHE INTERNAL "Single output directory for building all executables.")
endif()

mark_as_advanced(CMAKE_LIBRARY_OUTPUT_DIRECTORY EXECUTABLE_OUTPUT_PATH WRAP_ITK_INSTALL_PREFIX)

set(CXX_TEST_PATH ${EXECUTABLE_OUTPUT_PATH})

###############################################################################
# Additional files for installation
###############################################################################

install(FILES
  CMakeUtilityFunctions.cmake
  ConfigureWrapping.cmake
  TypedefMacros.cmake
  WrapBasicTypes.cmake
  WrapITKTypes.cmake
  DESTINATION "${WRAP_ITK_INSTALL_PREFIX}/Configuration"
)

install(FILES "${WrapITK_BINARY_DIR}/InstallOnly/WrapITKConfig.cmake"
  DESTINATION "${WRAP_ITK_INSTALL_PREFIX}/"
)

# Add a custom target to drive installation of the WrapITK-compatibility files
if(INSTALL_WRAP_ITK_COMPATIBILITY)
  # if we should by default install the files, make a custom target that will
  # always be built.
  CREATE_INSTALL_AT_ABSOLUTE_PATH_TARGET(install_wrapitk_compatibility DEFAULT
    "Installing WrapITK compatibility files. Requires admin priviliges: turn off INSTALL_WRAP_ITK_COMPATIBILITY in cmake to disable.")
else()
  # otherwise, add a target that will install the files only when that target is
  # manually built.
  CREATE_INSTALL_AT_ABSOLUTE_PATH_TARGET(install_wrapitk_compatibility ON_DEMAND
    "Installing WrapITK compatibility files. Requires admin priviliges.")
endif()

INSTALL_AT_ABSOLUTE_PATH(install_wrapitk_compatibility "${CMAKE_ROOT}/Modules" "${WrapITK_BINARY_DIR}/InstallOnly/FindWrapITK.cmake")

set(WRAP_ITK_TYPEDEFS_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/Typedefs")
set(WRAP_ITK_LIB_DIRECTORY  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")

###############################################################################
# Setup test driver
###############################################################################

set(ITK_TEST_DRIVER "itkTestDriver")

###############################################################################
# The real work on wrappers
###############################################################################

include(ConfigureWrapping.cmake)

###############################################################################
# let the different generators running some code before begining to parse the
# modules
###############################################################################

itk_wrap_modules()

###############################################################################
# Configure specific wrapper modules
###############################################################################

add_subdirectory("${CMAKE_CURRENT_SOURCE_DIR}/Modules" "${CMAKE_CURRENT_BINARY_DIR}/Modules")


###############################################################################
# let the different generators running some code after have parsed all the
# modules
###############################################################################

itk_end_wrap_modules()

###############################################################################
# Configure WrapITKConfig.cmake and FindWrapITK.cmake for external projects
###############################################################################
# First, configure for use directly from the build dir.
# we must add the options for the generators for the build dir case, so the
# external project won't find all the generators, even the usued ones.
# In the installed case, this feature is useful to let the packagers make several
# subpackages for wrapitk.
set(CONFIG_WRAP_ITK_MORE_OPTIONS)
foreach(lang ${WRAP_ITK_GENERATORS} ${WRAP_ITK_UNUSED_GENERATORS})
  string(TOUPPER "${lang}" lang_upper)
  set(CONFIG_WRAP_ITK_MORE_OPTIONS "${CONFIG_WRAP_ITK_MORE_OPTIONS}set(WRAP_ITK_${lang_upper} ${WRAP_ITK_${lang_upper}} CACHE BOOL \"Build swig ${lang} wrapper support.\")\n")
endforeach()
set(CONFIG_CONFIG_DIR "${WrapITK_SOURCE_DIR}/ConfigurationInputs")
set(CONFIG_CMAKE_DIR "${WrapITK_SOURCE_DIR}")
set(CONFIG_WRAP_ITK_TYPEDEFS_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/Typedefs")
set(CONFIG_WRAP_ITK_INSTALL_LOCATION "${CMAKE_INSTALL_PREFIX}/${WRAP_ITK_INSTALL_PREFIX}")
set(CONFIG_WRAP_ITK_MODULES "${WRAP_ITK_MODULES}")
set(CONFIG_ITK_WRAP_PYTHON_MODULE "${WrapITK_BINARY_DIR}/Python/\\\${CTEST_CONFIGURATION_TYPE}")
set(CONFIG_ITK_WRAP_PYTHON_LIBS "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}/\\\${CTEST_CONFIGURATION_TYPE}")
set(CONFIG_WRAP_ITK_LIB_DIR  "${CMAKE_LIBRARY_OUTPUT_DIRECTORY}")
configure_file("${WRAP_ITK_CONFIG_DIR}/WrapITKConfig.cmake.in"
               "${WrapITK_BINARY_DIR}/WrapITKConfig.cmake"
               @ONLY)

set(CONFIG_WRAP_ITK_DIR "${WrapITK_BINARY_DIR}")
configure_file("${WRAP_ITK_CONFIG_DIR}/FindWrapITK.cmake.in"
               "${WrapITK_BINARY_DIR}/FindWrapITK.cmake"
               @ONLY)

# Second, configure for installed use. Ensure that no absolute paths
# go into the installed config file, so that it is as portable as possible.
set(CONFIG_WRAP_ITK_MORE_OPTIONS)
set(CONFIG_CONFIG_DIR "\${WrapITK_DIR}/Configuration/Inputs")
set(CONFIG_CMAKE_DIR "\${WrapITK_DIR}/Configuration")
set(CONFIG_WRAP_ITK_TYPEDEFS_DIRECTORY "\${WrapITK_DIR}/Configuration/Typedefs")
set(CONFIG_WRAP_ITK_INSTALL_LOCATION "\${WrapITK_DIR}")
set(CONFIG_ITK_WRAP_PYTHON_MODULE "\${WrapITK_DIR}/Python/")
set(CONFIG_ITK_WRAP_PYTHON_LIBS "\${WrapITK_DIR}/lib")
set(CONFIG_WRAP_ITK_LIB_DIR  "\${WrapITK_DIR}/lib")
configure_file("${WRAP_ITK_CONFIG_DIR}/WrapITKConfig.cmake.in"
               "${WrapITK_BINARY_DIR}/InstallOnly/WrapITKConfig.cmake"
               @ONLY)

set(CONFIG_WRAP_ITK_DIR "${CMAKE_INSTALL_PREFIX}/${WRAP_ITK_INSTALL_PREFIX}")
configure_file("${WRAP_ITK_CONFIG_DIR}/FindWrapITK.cmake.in"
               "${WrapITK_BINARY_DIR}/InstallOnly/FindWrapITK.cmake"
               @ONLY)

=== Examples/Filtering/CMakeLists.txt ===
project(FilteringExamples)
include_regular_expression("^.*$")
add_executable(CompositeFilterExample CompositeFilterExample.cxx )
target_link_libraries(CompositeFilterExample  ${ITK_LIBRARIES})
add_executable(FlipImageFilter FlipImageFilter.cxx )
target_link_libraries(FlipImageFilter  ${ITK_LIBRARIES})
add_executable(FFTImageFilter FFTImageFilter.cxx )
target_link_libraries(FFTImageFilter  ${ITK_LIBRARIES})
if( ITK_USE_FFTWF )
  add_executable(FFTDirectInverse2 FFTDirectInverse2.cxx )
  target_link_libraries(FFTDirectInverse2  ${ITK_LIBRARIES})
endif()
add_executable(GradientMagnitudeImageFilter GradientMagnitudeImageFilter.cxx )
target_link_libraries(GradientMagnitudeImageFilter  ${ITK_LIBRARIES})
add_executable(GradientMagnitudeRecursiveGaussianImageFilter GradientMagnitudeRecursiveGaussianImageFilter.cxx )
target_link_libraries(GradientMagnitudeRecursiveGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(GradientRecursiveGaussianImageFilter GradientRecursiveGaussianImageFilter.cxx )
target_link_libraries(GradientRecursiveGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(GrayscaleFunctionDilateImageFilter GrayscaleFunctionDilateImageFilter.cxx )
target_link_libraries(GrayscaleFunctionDilateImageFilter  ${ITK_LIBRARIES})
add_executable(BinaryThresholdImageFilter BinaryThresholdImageFilter.cxx )
target_link_libraries(BinaryThresholdImageFilter  ${ITK_LIBRARIES})
add_executable(BinaryMedianImageFilter BinaryMedianImageFilter.cxx )
target_link_libraries(BinaryMedianImageFilter  ${ITK_LIBRARIES})
add_executable(OtsuThresholdImageFilter OtsuThresholdImageFilter.cxx )
target_link_libraries(OtsuThresholdImageFilter  ${ITK_LIBRARIES})
add_executable(OtsuMultipleThresholdImageFilter OtsuMultipleThresholdImageFilter.cxx )
target_link_libraries(OtsuMultipleThresholdImageFilter ${ITK_LIBRARIES})
add_executable(ThresholdImageFilter ThresholdImageFilter.cxx )
target_link_libraries(ThresholdImageFilter  ${ITK_LIBRARIES})
add_executable(CastingImageFilters CastingImageFilters.cxx )
target_link_libraries(CastingImageFilters  ${ITK_LIBRARIES})
add_executable(CannyEdgeDetectionImageFilter CannyEdgeDetectionImageFilter.cxx )
target_link_libraries(CannyEdgeDetectionImageFilter  ${ITK_LIBRARIES})
add_executable(MedianImageFilter MedianImageFilter.cxx )
target_link_libraries(MedianImageFilter  ${ITK_LIBRARIES})
add_executable(MeanImageFilter MeanImageFilter.cxx )
target_link_libraries(MeanImageFilter  ${ITK_LIBRARIES})
add_executable(MathematicalMorphologyBinaryFilters MathematicalMorphologyBinaryFilters.cxx )
target_link_libraries(MathematicalMorphologyBinaryFilters  ${ITK_LIBRARIES})
add_executable(MathematicalMorphologyGrayscaleFilters MathematicalMorphologyGrayscaleFilters.cxx )
target_link_libraries(MathematicalMorphologyGrayscaleFilters  ${ITK_LIBRARIES})
add_executable(BinaryMinMaxCurvatureFlowImageFilter BinaryMinMaxCurvatureFlowImageFilter.cxx )
target_link_libraries(BinaryMinMaxCurvatureFlowImageFilter  ${ITK_LIBRARIES})
add_executable(DiscreteGaussianImageFilter DiscreteGaussianImageFilter.cxx )
target_link_libraries(DiscreteGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(GaussianBlurImageFunction GaussianBlurImageFunction.cxx )
target_link_libraries(GaussianBlurImageFunction  ${ITK_LIBRARIES})
add_executable(LaplacianRecursiveGaussianImageFilter1 LaplacianRecursiveGaussianImageFilter1.cxx )
target_link_libraries(LaplacianRecursiveGaussianImageFilter1  ${ITK_LIBRARIES})
add_executable(ScaleSpaceGenerator2D ScaleSpaceGenerator2D.cxx )
target_link_libraries(ScaleSpaceGenerator2D  ${ITK_LIBRARIES})
add_executable(BinomialBlurImageFilter BinomialBlurImageFilter.cxx )
target_link_libraries(BinomialBlurImageFilter  ${ITK_LIBRARIES})
add_executable(CurvatureAnisotropicDiffusionImageFilter CurvatureAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(CurvatureAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(VectorGradientAnisotropicDiffusionImageFilter VectorGradientAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(VectorGradientAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(VectorCurvatureAnisotropicDiffusionImageFilter VectorCurvatureAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(VectorCurvatureAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(RGBToGrayscale RGBToGrayscale.cxx )
target_link_libraries(RGBToGrayscale  ${ITK_LIBRARIES})
add_executable(BilateralImageFilter BilateralImageFilter.cxx )
target_link_libraries(BilateralImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleOrientedImageFilter ResampleOrientedImageFilter.cxx )
target_link_libraries(ResampleOrientedImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter2 ResampleImageFilter2.cxx )
target_link_libraries(ResampleImageFilter2  ${ITK_LIBRARIES})
add_executable(GradientAnisotropicDiffusionImageFilter GradientAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(GradientAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(CurvatureFlowImageFilter CurvatureFlowImageFilter.cxx )
target_link_libraries(CurvatureFlowImageFilter  ${ITK_LIBRARIES})
add_executable(GradientVectorFlowImageFilter GradientVectorFlowImageFilter.cxx )
target_link_libraries(GradientVectorFlowImageFilter  ${ITK_LIBRARIES})
add_executable(SigmoidImageFilter SigmoidImageFilter.cxx )
target_link_libraries(SigmoidImageFilter  ${ITK_LIBRARIES})
add_executable(RGBCurvatureAnisotropicDiffusionImageFilter RGBCurvatureAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(RGBCurvatureAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(RGBGradientAnisotropicDiffusionImageFilter RGBGradientAnisotropicDiffusionImageFilter.cxx )
target_link_libraries(RGBGradientAnisotropicDiffusionImageFilter  ${ITK_LIBRARIES})
add_executable(SignedDanielssonDistanceMapImageFilter SignedDanielssonDistanceMapImageFilter.cxx )
target_link_libraries(SignedDanielssonDistanceMapImageFilter  ${ITK_LIBRARIES})
add_executable(SecondDerivativeRecursiveGaussianImageFilter SecondDerivativeRecursiveGaussianImageFilter.cxx )
target_link_libraries(SecondDerivativeRecursiveGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(DerivativeImageFilter DerivativeImageFilter.cxx )
target_link_libraries(DerivativeImageFilter  ${ITK_LIBRARIES})
add_executable(DanielssonDistanceMapImageFilter DanielssonDistanceMapImageFilter.cxx )
target_link_libraries(DanielssonDistanceMapImageFilter  ${ITK_LIBRARIES})
add_executable(AntiAliasBinaryImageFilter AntiAliasBinaryImageFilter.cxx )
target_link_libraries(AntiAliasBinaryImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter ResampleImageFilter.cxx )
target_link_libraries(ResampleImageFilter  ${ITK_LIBRARIES})
add_executable(SmoothingRecursiveGaussianImageFilter SmoothingRecursiveGaussianImageFilter.cxx )
target_link_libraries(SmoothingRecursiveGaussianImageFilter  ${ITK_LIBRARIES})
add_executable(SmoothingRecursiveGaussianImageFilter2 SmoothingRecursiveGaussianImageFilter2.cxx )
target_link_libraries(SmoothingRecursiveGaussianImageFilter2  ${ITK_LIBRARIES})
add_executable(LaplacianRecursiveGaussianImageFilter2 LaplacianRecursiveGaussianImageFilter2.cxx )
target_link_libraries(LaplacianRecursiveGaussianImageFilter2  ${ITK_LIBRARIES})
add_executable(MorphologicalImageEnhancement MorphologicalImageEnhancement.cxx )
target_link_libraries(MorphologicalImageEnhancement  ${ITK_LIBRARIES})
add_executable(MinMaxCurvatureFlowImageFilter MinMaxCurvatureFlowImageFilter.cxx )
target_link_libraries(MinMaxCurvatureFlowImageFilter  ${ITK_LIBRARIES})
add_executable(FFTImageFilterFourierDomainFiltering FFTImageFilterFourierDomainFiltering.cxx )
target_link_libraries(FFTImageFilterFourierDomainFiltering  ${ITK_LIBRARIES})
add_executable(LaplacianImageFilter LaplacianImageFilter.cxx )
target_link_libraries(LaplacianImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter3 ResampleImageFilter3.cxx )
target_link_libraries(ResampleImageFilter3  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter4 ResampleImageFilter4.cxx )
target_link_libraries(ResampleImageFilter4  ${ITK_LIBRARIES})
add_executable(VotingBinaryHoleFillingImageFilter VotingBinaryHoleFillingImageFilter.cxx )
target_link_libraries(VotingBinaryHoleFillingImageFilter  ${ITK_LIBRARIES})
add_executable(VotingBinaryIterativeHoleFillingImageFilter VotingBinaryIterativeHoleFillingImageFilter.cxx )
target_link_libraries(VotingBinaryIterativeHoleFillingImageFilter  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter5 ResampleImageFilter5.cxx )
target_link_libraries(ResampleImageFilter5  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter6 ResampleImageFilter6.cxx )
target_link_libraries(ResampleImageFilter6  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter8 ResampleImageFilter8.cxx )
target_link_libraries(ResampleImageFilter8  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter9 ResampleImageFilter9.cxx )
target_link_libraries(ResampleImageFilter9  ${ITK_LIBRARIES})
add_executable(ResampleVolumesToBeIsotropic ResampleVolumesToBeIsotropic.cxx )
target_link_libraries(ResampleVolumesToBeIsotropic  ${ITK_LIBRARIES})
add_executable(SubsampleVolume SubsampleVolume.cxx )
target_link_libraries(SubsampleVolume  ${ITK_LIBRARIES})
add_executable(SpatialObjectToImage1 SpatialObjectToImage1.cxx )
target_link_libraries(SpatialObjectToImage1  ${ITK_LIBRARIES})
add_executable(SpatialObjectToImage2 SpatialObjectToImage2.cxx )
target_link_libraries(SpatialObjectToImage2  ${ITK_LIBRARIES})
add_executable(SpatialObjectToImage3 SpatialObjectToImage3.cxx )
target_link_libraries(SpatialObjectToImage3  ${ITK_LIBRARIES})
add_executable(LaplacianSharpeningImageFilter LaplacianSharpeningImageFilter.cxx )
target_link_libraries(LaplacianSharpeningImageFilter  ${ITK_LIBRARIES})
add_executable(VectorIndexSelection VectorIndexSelection.cxx )
target_link_libraries(VectorIndexSelection  ${ITK_LIBRARIES})
add_executable(VesselnessMeasureImageFilter VesselnessMeasureImageFilter.cxx )
target_link_libraries(VesselnessMeasureImageFilter  ${ITK_LIBRARIES})
add_executable(DiffusionTensor3DReconstructionImageFilter DiffusionTensor3DReconstructionImageFilter.cxx)
target_link_libraries(DiffusionTensor3DReconstructionImageFilter ${ITK_LIBRARIES})
add_executable(FFTDirectInverse FFTDirectInverse.cxx )
target_link_libraries(FFTDirectInverse  ${ITK_LIBRARIES})
add_executable(ZeroCrossingBasedEdgeDetectionImageFilter ZeroCrossingBasedEdgeDetectionImageFilter.cxx )
target_link_libraries(ZeroCrossingBasedEdgeDetectionImageFilter  ${ITK_LIBRARIES})
add_executable(WarpImageFilter1 WarpImageFilter1.cxx )
target_link_libraries(WarpImageFilter1  ${ITK_LIBRARIES})
add_executable(SurfaceExtraction SurfaceExtraction.cxx )
target_link_libraries(SurfaceExtraction  ${ITK_LIBRARIES})
add_executable(DigitallyReconstructedRadiograph1 DigitallyReconstructedRadiograph1.cxx )
target_link_libraries(DigitallyReconstructedRadiograph1  ${ITK_LIBRARIES})
add_executable(ResampleImageFilter7 ResampleImageFilter7.cxx )
target_link_libraries(ResampleImageFilter7  ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Installation/CMakeLists.txt ===
# This is the root ITK CMakeLists file.
cmake_minimum_required(VERSION 2.4)
if(COMMAND CMAKE_POLICY)
  cmake_policy(SET CMP0003 NEW)
endif()


# This project is designed to be built outside the Insight source tree.
project(HelloWorld)

# Find ITK.
find_package(ITK REQUIRED)
include(${ITK_USE_FILE})

add_executable(HelloWorld HelloWorld.cxx )

target_link_libraries(HelloWorld ${ITK_LIBRARIES})

=== Examples/Iterators/CMakeLists.txt ===
#
#  Examples on the use of Iterators.
#
project(IteratorExamples)
include_regular_expression("^.*$")

add_executable(NeighborhoodIterators4 NeighborhoodIterators4.cxx)
target_link_libraries(NeighborhoodIterators4 ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators5 NeighborhoodIterators5.cxx)
target_link_libraries(NeighborhoodIterators5 ${ITK_LIBRARIES})

add_executable(ImageRandomConstIteratorWithIndex ImageRandomConstIteratorWithIndex.cxx)
target_link_libraries(ImageRandomConstIteratorWithIndex ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators1 NeighborhoodIterators1.cxx)
target_link_libraries(NeighborhoodIterators1 ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators2 NeighborhoodIterators2.cxx)
target_link_libraries(NeighborhoodIterators2 ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators3 NeighborhoodIterators3.cxx)
target_link_libraries(NeighborhoodIterators3 ${ITK_LIBRARIES})

add_executable(NeighborhoodIterators6 NeighborhoodIterators6.cxx)
target_link_libraries(NeighborhoodIterators6 ${ITK_LIBRARIES})

add_executable(ImageRegionIteratorWithIndex ImageRegionIteratorWithIndex.cxx)
target_link_libraries(ImageRegionIteratorWithIndex ${ITK_LIBRARIES})

add_executable(ImageRegionIterator ImageRegionIterator.cxx)
target_link_libraries(ImageRegionIterator ${ITK_LIBRARIES})

add_executable(ImageLinearIteratorWithIndex2 ImageLinearIteratorWithIndex2.cxx)
target_link_libraries(ImageLinearIteratorWithIndex2 ${ITK_LIBRARIES})

add_executable(ImageLinearIteratorWithIndex ImageLinearIteratorWithIndex.cxx)
target_link_libraries(ImageLinearIteratorWithIndex ${ITK_LIBRARIES})

add_executable(ImageSliceIteratorWithIndex ImageSliceIteratorWithIndex.cxx)
target_link_libraries(ImageSliceIteratorWithIndex ${ITK_LIBRARIES})

add_executable(ShapedNeighborhoodIterators1 ShapedNeighborhoodIterators1.cxx)
target_link_libraries(ShapedNeighborhoodIterators1 ${ITK_LIBRARIES})

add_executable(ShapedNeighborhoodIterators2 ShapedNeighborhoodIterators2.cxx)
target_link_libraries(ShapedNeighborhoodIterators2 ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Numerics/CMakeLists.txt ===
#
# Examples on the use of Numerics classes.
#
project(NumericsExamples)
include_regular_expression("^.*$")

add_executable(FourierDescriptors1 FourierDescriptors1.cxx )
target_link_libraries(FourierDescriptors1 ${ITK_LIBRARIES})

=== Examples/Registration/CMakeLists.txt ===
project(ImageRegistration)
include_regular_expression("^.*$")

add_executable(ImageRegistration3 ImageRegistration3.cxx )
target_link_libraries(ImageRegistration3 ${ITK_LIBRARIES})

add_executable(ImageRegistration5 ImageRegistration5.cxx )
target_link_libraries(ImageRegistration5 ${ITK_LIBRARIES})

add_executable(ImageRegistration6 ImageRegistration6.cxx )
target_link_libraries(ImageRegistration6 ${ITK_LIBRARIES})

add_executable(ImageRegistration8 ImageRegistration8.cxx )
target_link_libraries(ImageRegistration8 ${ITK_LIBRARIES})

add_executable(ImageRegistration9 ImageRegistration9.cxx )
target_link_libraries(ImageRegistration9 ${ITK_LIBRARIES})

add_executable(ImageRegistration10 ImageRegistration10.cxx )
target_link_libraries(ImageRegistration10 ${ITK_LIBRARIES})

add_executable(DeformableRegistration4 DeformableRegistration4.cxx )
target_link_libraries(DeformableRegistration4 ${ITK_LIBRARIES})

add_executable(ImageRegistration4 ImageRegistration4.cxx )
target_link_libraries(ImageRegistration4 ${ITK_LIBRARIES})

add_executable(ImageRegistration7 ImageRegistration7.cxx )
target_link_libraries(ImageRegistration7 ${ITK_LIBRARIES})

add_executable(ImageRegistration11 ImageRegistration11.cxx )
target_link_libraries(ImageRegistration11 ${ITK_LIBRARIES})

add_executable(ImageRegistration12 ImageRegistration12.cxx )
target_link_libraries(ImageRegistration12 ${ITK_LIBRARIES})

add_executable(ImageRegistration13 ImageRegistration13.cxx )
target_link_libraries(ImageRegistration13 ${ITK_LIBRARIES})

add_executable(ImageRegistration14 ImageRegistration14.cxx )
target_link_libraries(ImageRegistration14 ${ITK_LIBRARIES})

add_executable(ImageRegistration15 ImageRegistration15.cxx )
target_link_libraries(ImageRegistration15 ${ITK_LIBRARIES})

add_executable(ImageRegistration16 ImageRegistration16.cxx )
target_link_libraries(ImageRegistration16 ${ITK_LIBRARIES})

add_executable(ImageRegistration18 ImageRegistration18.cxx )
target_link_libraries(ImageRegistration18 ${ITK_LIBRARIES})

add_executable(ImageRegistration19 ImageRegistration19.cxx )
target_link_libraries(ImageRegistration19 ${ITK_LIBRARIES})

add_executable(ImageRegistration20 ImageRegistration20.cxx )
target_link_libraries(ImageRegistration20 ${ITK_LIBRARIES})

add_executable(DeformableRegistration6 DeformableRegistration6.cxx )
target_link_libraries(DeformableRegistration6 ${ITK_LIBRARIES})

add_executable(DeformableRegistration7 DeformableRegistration7.cxx )
target_link_libraries(DeformableRegistration7 ${ITK_LIBRARIES})

add_executable(DeformableRegistration8 DeformableRegistration8.cxx )
target_link_libraries(DeformableRegistration8 ${ITK_LIBRARIES})

if( ITK_USE_FFTWD )
  add_executable(DeformableRegistration9 DeformableRegistration9.cxx )
  target_link_libraries(DeformableRegistration9 ${ITK_LIBRARIES})

  add_executable(DeformableRegistration10 DeformableRegistration10.cxx )
  target_link_libraries(DeformableRegistration10 ${ITK_LIBRARIES})
endif()

add_executable(MultiResImageRegistration1 MultiResImageRegistration1.cxx )
target_link_libraries(MultiResImageRegistration1 ${ITK_LIBRARIES})

add_executable(MultiResImageRegistration2 MultiResImageRegistration2.cxx )
target_link_libraries(MultiResImageRegistration2 ${ITK_LIBRARIES})

add_executable(MultiResImageRegistration3 MultiResImageRegistration3.cxx )
target_link_libraries(MultiResImageRegistration3 ${ITK_LIBRARIES})

add_executable(DeformableRegistration1 DeformableRegistration1.cxx )
target_link_libraries(DeformableRegistration1 ${ITK_LIBRARIES})

add_executable(DeformableRegistration11 DeformableRegistration11.cxx )
target_link_libraries(DeformableRegistration11 ${ITK_LIBRARIES})

add_executable(DeformableRegistration2 DeformableRegistration2.cxx )
target_link_libraries(DeformableRegistration2 ${ITK_LIBRARIES})

add_executable(DeformableRegistration3 DeformableRegistration3.cxx )
target_link_libraries(DeformableRegistration3 ${ITK_LIBRARIES})

add_executable(DeformableRegistration5 DeformableRegistration5.cxx )
target_link_libraries(DeformableRegistration5 ${ITK_LIBRARIES})

add_executable(DeformableRegistration12 DeformableRegistration12.cxx )
target_link_libraries(DeformableRegistration12 ${ITK_LIBRARIES})

add_executable(DeformableRegistration13 DeformableRegistration13.cxx )
target_link_libraries(DeformableRegistration13 ${ITK_LIBRARIES})

add_executable(DeformableRegistration14 DeformableRegistration14.cxx )
target_link_libraries(DeformableRegistration14 ${ITK_LIBRARIES})

add_executable(ChangeInformationImageFilter ChangeInformationImageFilter.cxx )
target_link_libraries(ChangeInformationImageFilter ${ITK_LIBRARIES})

add_executable(DeformableRegistration15 DeformableRegistration15.cxx )
target_link_libraries(DeformableRegistration15 ${ITK_LIBRARIES})

add_executable(DeformableRegistration16 DeformableRegistration16.cxx )
target_link_libraries(DeformableRegistration16 ${ITK_LIBRARIES})

add_executable(DeformableRegistration17 DeformableRegistration17.cxx )
target_link_libraries(DeformableRegistration17 ${ITK_LIBRARIES})

add_executable(DisplacementFieldInitialization DisplacementFieldInitialization.cxx )
target_link_libraries(DisplacementFieldInitialization ${ITK_LIBRARIES})

add_executable(LandmarkWarping2 LandmarkWarping2.cxx )
target_link_libraries(LandmarkWarping2 ${ITK_LIBRARIES})

add_executable(BSplineWarping1 BSplineWarping1.cxx )
target_link_libraries(BSplineWarping1 ${ITK_LIBRARIES})

add_executable(BSplineWarping2 BSplineWarping2.cxx )
target_link_libraries(BSplineWarping2 ${ITK_LIBRARIES})

add_executable(ThinPlateSplineWarp ThinPlateSplineWarp.cxx )
target_link_libraries(ThinPlateSplineWarp ${ITK_LIBRARIES})

add_executable(ModelToImageRegistration1 ModelToImageRegistration1.cxx )
target_link_libraries(ModelToImageRegistration1 ${ITK_LIBRARIES})

add_executable(ModelToImageRegistration2 ModelToImageRegistration2.cxx )
target_link_libraries(ModelToImageRegistration2 ${ITK_LIBRARIES})

add_executable(ImageRegistration1 ImageRegistration1.cxx )
target_link_libraries(ImageRegistration1 ${ITK_LIBRARIES})

add_executable(ImageRegistration2 ImageRegistration2.cxx )
target_link_libraries(ImageRegistration2 ${ITK_LIBRARIES})

add_executable(ImageRegistration17 ImageRegistration17.cxx )
target_link_libraries(ImageRegistration17 ${ITK_LIBRARIES})

add_executable(ImageRegistrationHistogramPlotter ImageRegistrationHistogramPlotter.cxx )
target_link_libraries(ImageRegistrationHistogramPlotter ${ITK_LIBRARIES})

add_executable(MeanSquaresImageMetric1  MeanSquaresImageMetric1.cxx )
target_link_libraries(MeanSquaresImageMetric1 ${ITK_LIBRARIES})

if(ITKV3_COMPATIBILITY)
  add_executable(DeformationFieldJacobian DeformationFieldJacobian.cxx )
  target_link_libraries(DeformationFieldJacobian ${ITK_LIBRARIES})
endif()

add_executable(IterativeClosestPoint1   IterativeClosestPoint1.cxx )
target_link_libraries(IterativeClosestPoint1 ${ITK_LIBRARIES})

add_executable(IterativeClosestPoint2   IterativeClosestPoint2.cxx )
target_link_libraries(IterativeClosestPoint2 ${ITK_LIBRARIES})

add_executable(IterativeClosestPoint3   IterativeClosestPoint3.cxx )
target_link_libraries(IterativeClosestPoint3 ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/Segmentation/CMakeLists.txt ===
#
# Examples on the use of segmentation algorithms
#

project(ImageSegmentation)
include_regular_expression("^.*$")

add_executable(ConfidenceConnected ConfidenceConnected.cxx )
target_link_libraries(ConfidenceConnected ${ITK_LIBRARIES})

add_executable(ConfidenceConnected3D ConfidenceConnected3D.cxx )
target_link_libraries(ConfidenceConnected3D ${ITK_LIBRARIES})

add_executable(NeighborhoodConnectedImageFilter NeighborhoodConnectedImageFilter.cxx )
target_link_libraries(NeighborhoodConnectedImageFilter ${ITK_LIBRARIES})

add_executable(IsolatedConnectedImageFilter IsolatedConnectedImageFilter.cxx )
target_link_libraries(IsolatedConnectedImageFilter ${ITK_LIBRARIES})

add_executable(ConnectedThresholdImageFilter ConnectedThresholdImageFilter.cxx )
target_link_libraries(ConnectedThresholdImageFilter ${ITK_LIBRARIES})

add_executable(FastMarchingImageFilter FastMarchingImageFilter.cxx )
target_link_libraries(FastMarchingImageFilter ${ITK_LIBRARIES})

add_executable(GeodesicActiveContourShapePriorLevelSetImageFilter
GeodesicActiveContourShapePriorLevelSetImageFilter.cxx )
target_link_libraries(GeodesicActiveContourShapePriorLevelSetImageFilter ${ITK_LIBRARIES})

add_executable(GibbsPriorImageFilter1 GibbsPriorImageFilter1.cxx )
target_link_libraries(GibbsPriorImageFilter1 ${ITK_LIBRARIES})

add_executable(HoughTransform2DCirclesImageFilter HoughTransform2DCirclesImageFilter.cxx )
target_link_libraries(HoughTransform2DCirclesImageFilter ${ITK_LIBRARIES})

add_executable(HoughTransform2DLinesImageFilter HoughTransform2DLinesImageFilter.cxx )
target_link_libraries(HoughTransform2DLinesImageFilter ${ITK_LIBRARIES})

add_executable(VectorConfidenceConnected VectorConfidenceConnected.cxx )
target_link_libraries(VectorConfidenceConnected ${ITK_LIBRARIES})

add_executable(RelabelComponentImageFilter RelabelComponentImageFilter.cxx )
target_link_libraries(RelabelComponentImageFilter ${ITK_LIBRARIES})

add_executable(CannySegmentationLevelSetImageFilter CannySegmentationLevelSetImageFilter.cxx )
target_link_libraries(CannySegmentationLevelSetImageFilter ${ITK_LIBRARIES})

add_executable(GeodesicActiveContourImageFilter GeodesicActiveContourImageFilter.cxx )
target_link_libraries(GeodesicActiveContourImageFilter ${ITK_LIBRARIES})

add_executable(ShapeDetectionLevelSetFilter ShapeDetectionLevelSetFilter.cxx )
target_link_libraries(ShapeDetectionLevelSetFilter ${ITK_LIBRARIES})

add_executable(CurvesLevelSetImageFilter CurvesLevelSetImageFilter.cxx )
target_link_libraries(CurvesLevelSetImageFilter ${ITK_LIBRARIES})

add_executable(WatershedSegmentation1 WatershedSegmentation1.cxx )
target_link_libraries(WatershedSegmentation1 ${ITK_LIBRARIES})

add_executable(WatershedSegmentation2 WatershedSegmentation2.cxx )
target_link_libraries(WatershedSegmentation2 ${ITK_LIBRARIES})

add_executable(CellularSegmentation1 CellularSegmentation1.cxx )
target_link_libraries(CellularSegmentation1 ${ITK_LIBRARIES})

add_executable(CellularSegmentation2 CellularSegmentation2.cxx )
target_link_libraries(CellularSegmentation2 ${ITK_LIBRARIES})

add_executable(LaplacianSegmentationLevelSetImageFilter LaplacianSegmentationLevelSetImageFilter.cxx )
target_link_libraries(LaplacianSegmentationLevelSetImageFilter ${ITK_LIBRARIES})

add_executable(ThresholdSegmentationLevelSetImageFilter ThresholdSegmentationLevelSetImageFilter.cxx )
target_link_libraries(ThresholdSegmentationLevelSetImageFilter ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Examples/SpatialObjects/CMakeLists.txt ===
#
#  Examples on the use of SpatialObjects.
#
project(SpatialObjectsExamples)
include_regular_expression("^.*$")

add_executable(ArrowSpatialObject ArrowSpatialObject.cxx)
target_link_libraries(ArrowSpatialObject  ${ITK_LIBRARIES})

add_executable(BlobSpatialObject BlobSpatialObject.cxx)
target_link_libraries(BlobSpatialObject  ${ITK_LIBRARIES})

add_executable(CylinderSpatialObject CylinderSpatialObject.cxx)
target_link_libraries(CylinderSpatialObject  ${ITK_LIBRARIES})

add_executable(EllipseSpatialObject EllipseSpatialObject.cxx)
target_link_libraries(EllipseSpatialObject  ${ITK_LIBRARIES})

add_executable(GaussianSpatialObject GaussianSpatialObject.cxx)
target_link_libraries(GaussianSpatialObject  ${ITK_LIBRARIES})

add_executable(GroupSpatialObject GroupSpatialObject.cxx)
target_link_libraries(GroupSpatialObject  ${ITK_LIBRARIES})

add_executable(ImageSpatialObject ImageSpatialObject.cxx)
target_link_libraries(ImageSpatialObject  ${ITK_LIBRARIES})

add_executable(ImageMaskSpatialObject ImageMaskSpatialObject.cxx)
target_link_libraries(ImageMaskSpatialObject  ${ITK_LIBRARIES})

add_executable(LandmarkSpatialObject LandmarkSpatialObject.cxx)
target_link_libraries(LandmarkSpatialObject  ${ITK_LIBRARIES})

add_executable(LineSpatialObject LineSpatialObject.cxx)
target_link_libraries(LineSpatialObject  ${ITK_LIBRARIES})

add_executable(MeshSpatialObject MeshSpatialObject.cxx)
target_link_libraries(MeshSpatialObject  ${ITK_LIBRARIES})

add_executable(ReadWriteSpatialObject ReadWriteSpatialObject.cxx)
target_link_libraries(ReadWriteSpatialObject  ${ITK_LIBRARIES})

add_executable(SceneSpatialObject SceneSpatialObject.cxx)
target_link_libraries(SceneSpatialObject  ${ITK_LIBRARIES})

add_executable(SpatialObjectHierarchy SpatialObjectHierarchy.cxx)
target_link_libraries(SpatialObjectHierarchy  ${ITK_LIBRARIES})

add_executable(SpatialObjectTransforms SpatialObjectTransforms.cxx)
target_link_libraries(SpatialObjectTransforms  ${ITK_LIBRARIES})

add_executable(SpatialObjectTreeContainer SpatialObjectTreeContainer.cxx)
target_link_libraries(SpatialObjectTreeContainer  ${ITK_LIBRARIES})

add_executable(SpatialObjectToImageStatisticsCalculator SpatialObjectToImageStatisticsCalculator.cxx)
target_link_libraries(SpatialObjectToImageStatisticsCalculator  ${ITK_LIBRARIES})

add_executable(SurfaceSpatialObject SurfaceSpatialObject.cxx)
target_link_libraries(SurfaceSpatialObject  ${ITK_LIBRARIES})

add_executable(TubeSpatialObject TubeSpatialObject.cxx)
target_link_libraries(TubeSpatialObject  ${ITK_LIBRARIES})

add_executable(VesselTubeSpatialObject VesselTubeSpatialObject.cxx)
target_link_libraries(VesselTubeSpatialObject  ${ITK_LIBRARIES})

add_executable(DTITubeSpatialObject DTITubeSpatialObject.cxx)
target_link_libraries(DTITubeSpatialObject  ${ITK_LIBRARIES})

add_executable(BoundingBoxFromImageMaskSpatialObject BoundingBoxFromImageMaskSpatialObject.cxx)
target_link_libraries(BoundingBoxFromImageMaskSpatialObject  ${ITK_LIBRARIES})

=== Examples/Statistics/CMakeLists.txt ===
project(StatisticsExamples)
include_regular_expression("^.*$")


add_executable(BayesianPluginClassifier BayesianPluginClassifier.cxx )
target_link_libraries(BayesianPluginClassifier ${ITK_LIBRARIES})

add_executable( BayesianClassifierInitializer BayesianClassifierInitializer.cxx )
target_link_libraries(BayesianClassifierInitializer ${ITK_LIBRARIES})

add_executable( BayesianClassifier BayesianClassifier.cxx )
target_link_libraries(BayesianClassifier ${ITK_LIBRARIES})

add_executable(EuclideanDistanceMetric EuclideanDistanceMetric.cxx )
target_link_libraries(EuclideanDistanceMetric ${ITK_LIBRARIES})

add_executable(ExpectationMaximizationMixtureModelEstimator ExpectationMaximizationMixtureModelEstimator.cxx )
target_link_libraries(ExpectationMaximizationMixtureModelEstimator ${ITK_LIBRARIES})

add_executable(GaussianMembershipFunction GaussianMembershipFunction.cxx )
target_link_libraries(GaussianMembershipFunction ${ITK_LIBRARIES})

add_executable(Histogram Histogram.cxx )
target_link_libraries(Histogram ${ITK_LIBRARIES})

add_executable(KdTree KdTree.cxx )
target_link_libraries(KdTree ${ITK_LIBRARIES})

add_executable(KdTreeBasedKMeansClustering KdTreeBasedKMeansClustering.cxx )
target_link_libraries(KdTreeBasedKMeansClustering ${ITK_LIBRARIES})

add_executable(ListSample ListSample.cxx )
target_link_libraries(ListSample ${ITK_LIBRARIES})

add_executable(SampleToHistogramFilter SampleToHistogramFilter.cxx )
target_link_libraries(SampleToHistogramFilter ${ITK_LIBRARIES})

add_executable(MaximumDecisionRule MaximumDecisionRule.cxx )
target_link_libraries(MaximumDecisionRule ${ITK_LIBRARIES})

add_executable(MaximumRatioDecisionRule MaximumRatioDecisionRule.cxx )
target_link_libraries(MaximumRatioDecisionRule ${ITK_LIBRARIES})

add_executable(MembershipSample MembershipSample.cxx )
target_link_libraries(MembershipSample ${ITK_LIBRARIES})

add_executable(MinimumDecisionRule MinimumDecisionRule.cxx )
target_link_libraries(MinimumDecisionRule ${ITK_LIBRARIES})
#
# At the moment, itkNeighborhoodSampler is incomplete, so this example
# can't be updated
#
#add_executable(NeighborhoodSampler NeighborhoodSampler.cxx )
#target_link_libraries(NeighborhoodSampler ${ITK_LIBRARIES})

add_executable(NormalVariateGenerator NormalVariateGenerator.cxx )
target_link_libraries(NormalVariateGenerator ${ITK_LIBRARIES})

add_executable(PointSetToListSampleAdaptor PointSetToListSampleAdaptor.cxx )
target_link_libraries(PointSetToListSampleAdaptor ${ITK_LIBRARIES})

add_executable(SampleStatistics SampleStatistics.cxx )
target_link_libraries(SampleStatistics ${ITK_LIBRARIES})

add_executable(SampleSorting SampleSorting.cxx )
target_link_libraries(SampleSorting ${ITK_LIBRARIES})

add_executable(WeightedSampleStatistics WeightedSampleStatistics.cxx )
target_link_libraries(WeightedSampleStatistics ${ITK_LIBRARIES})

add_executable(ImageHistogram3 ImageHistogram3.cxx )
target_link_libraries(ImageHistogram3 ${ITK_LIBRARIES})

add_executable(ScalarImageMarkovRandomField1 ScalarImageMarkovRandomField1.cxx )
target_link_libraries(ScalarImageMarkovRandomField1 ${ITK_LIBRARIES})

add_executable(ScalarImageKmeansClassifier ScalarImageKmeansClassifier.cxx )
target_link_libraries(ScalarImageKmeansClassifier ${ITK_LIBRARIES})

add_executable(ImageToListSampleAdaptor ImageToListSampleAdaptor.cxx )
target_link_libraries(ImageToListSampleAdaptor ${ITK_LIBRARIES})

add_executable(ImageHistogram1 ImageHistogram1.cxx )
target_link_libraries(ImageHistogram1 ${ITK_LIBRARIES})

add_executable(ImageHistogram2 ImageHistogram2.cxx )
target_link_libraries(ImageHistogram2 ${ITK_LIBRARIES})

add_executable(ImageHistogram4 ImageHistogram4.cxx )
target_link_libraries(ImageHistogram4 ${ITK_LIBRARIES})

add_executable(ImageEntropy1 ImageEntropy1.cxx )
target_link_libraries(ImageEntropy1 ${ITK_LIBRARIES})

add_executable(ImageMutualInformation1 ImageMutualInformation1.cxx )
target_link_libraries(ImageMutualInformation1 ${ITK_LIBRARIES})

add_executable(ScalarImageKmeansModelEstimator ScalarImageKmeansModelEstimator.cxx )
target_link_libraries(ScalarImageKmeansModelEstimator ${ITK_LIBRARIES})

if(BUILD_TESTING)
  add_subdirectory(test)
endif()

=== Testing/TestExternal/CMakeLists.txt ===
# This project builds the test directories from all ITK modules as a separate
# project outside the main ITK build tree as if they were an application.
cmake_minimum_required(VERSION 2.8 FATAL_ERROR)
project(ITKTestExternal)
if(ITK_SOURCE_DIR OR ITK_BINARY_DIR)
  message(FATAL_ERROR "This directory may build only outside ITK!")
endif()

include(CTest)

# Find the top of the main ITK source tree.
get_filename_component(ITK_TOP_DIR ${ITKTestExternal_SOURCE_DIR}/../.. ABSOLUTE)
set(ExternalData_SOURCE_ROOT ${ITK_TOP_DIR})

# Load module infrastructure macros.
include(${ITK_TOP_DIR}/CMake/ITKModuleMacros.cmake)
include(${ITK_TOP_DIR}/CMake/ITKExternalData.cmake)

# Tell modules how to add their tests.
function(itk_add_test)
  # Add tests with data in the ITKData group.
  ExternalData_add_test(ITKData ${ARGN})
endfunction()

# Find the ITK build or install tree.  Assume the version matches exactly.
# One should provide ITK_DIR explicitly in our intended use cases.
find_package(ITK REQUIRED NO_MODULE)

# Use ITK's flags.
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${ITK_REQUIRED_C_FLAGS}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${ITK_REQUIRED_CXX_FLAGS}")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} ${ITK_REQUIRED_LINK_FLAGS}")

# This is a cross-platform project so we cannot use the MS _s API.
if(WIN32 AND "${CMAKE_C_COMPILER_ID}" MATCHES "^(Intel)$")
  set(_INTEL_WINDOWS 1)
endif()
if(MSVC OR _INTEL_WINDOWS)
  add_definitions(
    -D_CRT_NONSTDC_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE
    -D_SCL_SECURE_NO_DEPRECATE
    )
endif()

# Glob the set modules in the source tree.
file(GLOB meta RELATIVE "${ITK_TOP_DIR}"
   "${ITK_TOP_DIR}/*/*/*/itk-module.cmake" # grouped modules
  )
# Identify the subset of modules that have tests.
foreach(f ${meta})
  get_filename_component(_base ${f} PATH)
  if(EXISTS ${ITK_TOP_DIR}/${_base}/test)
    include(${ITK_TOP_DIR}/${f})
    set(${itk-module}_TEST_DIR ${_base}/test)
    unset(itk-module)
  endif()
endforeach()

# Input information for test build files.
set(ITK_DATA_ROOT ${ITK_TOP_DIR}/Testing/Data)
set(ITK_EXAMPLE_DATA_ROOT ${ITK_TOP_DIR}/Examples/Data)
set(ITK_TEST_OUTPUT_DIR "${ITKTestExternal_BINARY_DIR}/Testing/Temporary")
include(${ITK_TOP_DIR}/Modules/Core/TestKernel/CreateTestDriver.cmake)

# Add the test directory for each enabled module that has tests.
foreach(itk-module ${ITK_MODULES_ENABLED})
  if(${itk-module}_TEST_DIR)
    add_subdirectory(${ITK_TOP_DIR}/${${itk-module}_TEST_DIR}
                     ${ITKTestExternal_BINARY_DIR}/${${itk-module}_TEST_DIR})
  endif()
endforeach()

# Create target to download data from the ITKData group.  This must come after
# all tests have been added that reference the group, so we put it last.
ExternalData_Add_Target(ITKData)

=== debian/changelog ===
insighttoolkit4 (4.5.0-3) unstable; urgency=low

  * Team upload.
  * Prefer system install GDCM. Closes: #728121
  * Depends on dcmtk headers. Closes: #734590
  * Use Depends: libtiff-dev. Closes: #736128

 -- Mathieu Malaterre <malat@debian.org>  Wed, 12 Feb 2014 12:49:24 +0100

insighttoolkit4 (4.5.0-2) unstable; urgency=low

  * rules: Enable module ITKDCMTK (using system DCMTK).  Enable 
    module Review (closes: #733602).
  * control.in: Build-depend on libdcmtk2-dev.
  * patches/nrrdio-linking.patch: New.  Link libITKNrrdIO with -lm.
    Closes: #733628.

 -- Steve M. Robbins <smr@debian.org>  Thu, 02 Jan 2014 22:56:27 -0600

insighttoolkit4 (4.5.0-1) unstable; urgency=low

  * New upstream.
  
  * control.in: Remove libvxl1-dev build-dep.  Update to Standards-Version
    3.9.5.

  * rules: Remove obsoleted options ITK_USE_MINC2 and ITK_USE_REVIEW.
  
  * watch: Change pattern from .tar.gz --> .tar.xz.
  
  * copyright: Replaced with new upstream license text.

 -- Steve M. Robbins <smr@debian.org>  Sun, 29 Dec 2013 00:36:24 -0600

insighttoolkit4 (4.4.2-4) unstable; urgency=low

  * control.in: Remove gdcm depdendency from -dev package.

 -- Steve M. Robbins <smr@debian.org>  Fri, 20 Sep 2013 20:50:08 -0500

insighttoolkit4 (4.4.2-3) unstable; urgency=low

  * control.in: Remove build-dep on libgdcm2-dev.

 -- Steve M. Robbins <smr@debian.org>  Fri, 20 Sep 2013 04:05:19 -0500

insighttoolkit4 (4.4.2-2) unstable; urgency=low

  * control.in: Restrict to architectures amd64 and i386.
  * rules: Configure with select system libraries.

 -- Steve M. Robbins <smr@debian.org>  Tue, 17 Sep 2013 19:39:27 -0500

insighttoolkit4 (4.4.2-1) unstable; urgency=low

  * New upstream.
  * rules: remove ITKv3 compatability code.

 -- Steve M. Robbins <smr@debian.org>  Sun, 08 Sep 2013 23:55:58 -0500

insighttoolkit4 (4.4.0-1) unstable; urgency=low

  * New upstream.

 -- Steve M. Robbins <smr@debian.org>  Sun, 09 Jun 2013 22:31:44 -0500

=== debian/control ===
Source: insighttoolkit4
Homepage: http://www.itk.org/
Section: science
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steve M. Robbins <smr@debian.org>
Build-Depends: debhelper (>= 9),
 cmake, cableswig (>= 0.1.0+cvs20110226), gccxml (>= 0.9.0+cvs20110723),
 zlib1g-dev (>= 1.2.2), libpng12-dev, libtiff-dev,
 libdcmtk2-dev, libgdcm2-dev, libdouble-conversion-dev,
 uuid-dev, libminc-dev, libhdf5-dev,
 libvtk5-dev, python-vtk
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/viewvc/debian-med/trunk/packages/insighttoolkit/trunk/
Vcs-Svn: svn://svn.debian.org/debian-med/trunk/packages/insighttoolkit/trunk/

Package: libinsighttoolkit4.5
Section: libs
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Image processing toolkit for registration and segmentation - runtime
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the libraries needed to run ITK applications.

Package: libinsighttoolkit4-dev
Section: libdevel
Architecture: amd64 i386
Depends: ${shlibs:Depends}, ${misc:Depends}, libinsighttoolkit4.5 (= ${binary:Version}), libgdcm2-dev, libdcmtk2-dev
Recommends: libfftw3-dev, uuid-dev
Conflicts: libinsighttoolkit-dev, libinsighttoolkit3-dev
Replaces: libinsighttoolkit-dev
Suggests: insighttoolkit4-examples
Description: Image processing toolkit for registration and segmentation - development
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the development files needed to build your own
 ITK applications.

Package: insighttoolkit4-examples
Section: devel
Architecture: all
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libinsighttoolkit4-dev
Conflicts: insighttoolkit-examples
Replaces: insighttoolkit-examples
Description: Image processing toolkit for registration and segmentation - examples
 ITK is an open-source software toolkit for performing registration and
 segmentation. Segmentation is the process of identifying and
 classifying data found in a digitally sampled
 representation. Typically the sampled representation is an image
 acquired from such medical instrumentation as CT or MRI
 scanners. Registration is the task of aligning or developing
 correspondences between data. For example, in the medical
 environment, a CT scan may be aligned with a MRI scan in order to
 combine the information contained in both.
 .
 This package contains the source for example programs.

=== debian/rules ===
#!/usr/bin/make -f

VER_MAJOR = 4
VER_MINOR = 5

# TODO: turn on the following:
#
# system HDF5 (omits C++ bindings; Bug #660547)
# system FFTW (test failures; see http://lists.debian.org/debian-med/2012/04/msg00064.html)
# system VXL (Bug #656837)
# Module_ITKLevelSetsv4Visualization (https://issues.itk.org/jira/browse/ITK-2856)
# Module_ITKVideoBridgeOpenCV (undiagnosed build error)
# Module_ITKVideoBridgeVXL (undiagnosed build error)
# Module_ITKVtkGlue (https://issues.itk.org/jira/browse/ITK-2856)

CMAKE_FLAGS = \
	-DBUILD_EXAMPLES:BOOL=ON \
	-DBUILD_SHARED_LIBS:BOOL=ON \
	-DBUILD_TESTING:BOOL=ON \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DCMAKE_EXPORT_COMPILE_COMMANDS:BOOL=ON \
	-DCMAKE_SKIP_RPATH:BOOL=ON \
	-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON \
	-DITK_USE_FFTWD:BOOL=OFF \
	-DITK_USE_FFTWF:BOOL=OFF \
	-DITK_USE_STRICT_CONCEPT_CHECKING:BOOL=ON \
	-DITK_USE_SYSTEM_DCMTK:BOOL=ON \
	-DITK_USE_SYSTEM_FFTW:BOOL=OFF \
	-DITK_USE_SYSTEM_GDCM:BOOL=ON \
	-DITK_USE_SYSTEM_DOUBLECONVERSION:BOOL=OFF \
	-DITK_USE_SYSTEM_HDF5:BOOL=OFF \
	-DITK_USE_SYSTEM_JPEG:BOOL=ON \
	-DITK_USE_SYSTEM_PNG:BOOL=ON \
	-DITK_USE_SYSTEM_TIFF:BOOL=ON \
	-DITK_USE_SYSTEM_VXL:BOOL=OFF \
	-DITK_USE_SYSTEM_ZLIB:BOOL=ON \
	-DModule_ITKDCMTK:BOOL=ON \
	-DModule_ITKIOPhilipsREC:BOOL=OFF \
	-DModule_ITKLevelSetsv4Visualization:BOOL=OFF \
	-DModule_ITKReview:BOOL=ON \
	-DModule_ITKVideoBridgeOpenCV:BOOL=OFF \
	-DModule_ITKVideoBridgeVXL:BOOL=OFF \
	-DModule_ITKVtkGlue:BOOL=OFF \
	-DVCL_INCLUDE_CXX_0X:BOOL=ON

SOVERSION = $(VER_MAJOR).$(VER_MINOR)

pkg_lib = libinsighttoolkit$(SOVERSION)
pkg_dev = libinsighttoolkit$(VER_MAJOR)-dev
pkg_examples = insighttoolkit$(VER_MAJOR)-examples


%:
	dh $@ --builddir=BUILD --parallel

override_dh_auto_configure: pre-build
	dh_auto_configure -- $(CMAKE_FLAGS)

pre-build:
	echo "Available disk space:"
	df -h .

override_dh_auto_test:
	LD_LIBRARY_PATH=`pwd`/BUILD/lib dh_auto_test

override_dh_lintian:
	echo "$(pkg_lib): package-name-doesnt-match-sonames" > debian/$(pkg_lib).lintian-overrides
	dh_lintian

override_dh_install: 
	# pkg_lib
	dh_install -p$(pkg_lib) -XJava -XPython -XTcl debian/tmp/usr/lib/lib*.so.* usr/lib
	cp CMake/InsightValgrind.supp Insight$(SOVERSION)Valgrind.supp
	cp Modules/ThirdParty/VNL/src/vxl/config/valgrind.supp Insight$(SOVERSION)VxlValgrind.supp
	dh_install -p$(pkg_lib) Insight$(SOVERSION)*.supp usr/lib/valgrind
	#
	# pkg_dev
	dh_installman -p$(pkg_dev) debian/insighttoolkit.3
	dh_installdocs -p$(pkg_dev) Documentation/*
	dh_install -p$(pkg_dev) -XJava -XPython -XTcl debian/tmp/usr/lib/lib*.so usr/lib
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/include/ITK-$(SOVERSION)/*
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/lib/cmake
	dh_install -p$(pkg_dev) --autodest debian/tmp/usr/bin/itkTestDriver
#	dh_install -p$(pkg_dev) Wrapping/WrapITK /usr/src

override_dh_installexamples:
	# pkg_examples
	dh_installexamples -p$(pkg_examples) Examples/*
ifneq (,$(filter $(pkg_examples), $(shell dh_listpackages)))
	find debian/$(pkg_examples)/usr/share/doc/$(pkg_examples)/examples \
	    -type f -print0 | xargs -0 chmod 644
endif

control-file:
	sed -e "s/@VER_MAJOR@/$(VER_MAJOR)/g" \
	    -e "s/@SOVERSION@/$(SOVERSION)/g" \
	    < debian/control.in > debian/control.tmp
	[ -e debian/control ] \
	  && cmp -s debian/control debian/control.tmp \
	  && rm -f debian/control.tmp && exit 0; \
	  mv debian/control.tmp debian/control
